Solid Edge Importer Overview

Solid Edgeâ Assembly & Parts Import Converter

Quick Jump:

Visual Snapshot Index of Each Import Converter Panel

This help file describes the Solid Edge import converter module which allows geometry, hierarchy and materials to be imported from native disk-based Solid Edge files or from a running copy of the Solid Edge 3D solid modeling application using the Solid Edge automation API. No intermediate files are used in the translation.

This import converter allows data to be directly imported from Solid Edge into any Okino compliant program, such as NuGraf, PolyTrans, the 3ds Max native plug-ins, or the Maya native plug-in module.

Solid Edgeâ is a registered trademark of Siemens. 3ds Maxâ and Mayaâ are registered trademarks of Autodesk. All other brand names, product names or trademarks belong to their respective holders.


Features of the Solid Edge Import Conversion System

· Import from a live running copy of Solid Edge, or from native Solid Edge files on disk (no copy of Solid Edge required for this latter feature). Solid Edge "Synchronous" and its related new file formats are also supported.

· The Solid Edge importer reads in native Solid Edge assembly (.asm), part (.par), sheet metal (.psm) and weldment (.pwd) files. Solid Edge v20 or older weldment files need to be re-saved from Solid Edge v100 (synchronous versions) if you wish to import via the "Display List" import method.

· Imports and retains: assembly hierarchy information and assembly names, as well as BREP structure of the source model (bodies and faces). Can query accurate vertex normals, uv texture coordinates and UV tangent vectors from Solid Edge directly.

· The quality of the model (the number of polygons) can be controlled when importing from Solid Edge (but not when importing from files directly on disk).

· If one part is instantiated N times in the Solid Edge assembly tree then this importer will recognize such a situation and use Okino's core database master/instance capability to import the part just once and instantiate it N times.

· The native PolyTrans plug-in systems for 3ds Max (PolyTrans-for-3dsMax) and Maya (PolyTrans-for-Maya) have been refined since 1998 specifically for importing large CAD assembly models from Solid Edge. This has come about partly from our good software users, and also from the main Okino CAD programmers who have been specializing in CAD to non-CAD conversion software since 1988.

· A good number of important options that can be (optionally) set prior to import, to control most situations that could be encountered with Solid Edge data import. Many options have come about from end-user requirements or situations.

· Complete control over material parameter modification on an automatic basis. Many CAD systems like Solid Edge have basic material parameters (like color, ambient + diffuse shading coefficients, opacity, etc) but when they are transferred over to a rendering and animation system they often look "too bright" or "highly ambient". This can be expected and is quite normal. The material tweak parameters easily allow such saturated shading values to be automatically compensated.

· If you are importing the Solid Edge data into Okino's PolyTrans or NuGraf software then it is possible to "refresh" or "update" the scene data directly from Solid Edge without having to re-import the whole scene again.

See Also:

Visual Snapshot Index of Each Import Converter Panel

Runtime Suggestions on How To Use the CD Importers Properly & Efficiently

Important Runtime Information, How-To’s, and Execution Notes

Solid Edge "COM Automation Server" - An Overview

Alternative Methods to Importing Solid Edge Data

The File Import Process Using Okino’s PolyTrans or NuGraf


Visual Snapshot Index of Each Import Converter Panel

Click below for help on any Solid Edge import converter panel:

Intro Panel | Data Source Selection | Beginner/Expert Mode
Display-List/Automation | Beginner Precision | Expert Precision
Expert Precision # 2 | Material Import | Material Tweaks

Errors, Statistics & Scaling


Runtime Suggestions

This short section explains the most fundamental and important suggestions that we pass on to users of the Solid Edge CAD importer. Taking into account these suggestions will make your usage of the software highly efficient. This section is accessible by pressing the "Suggestions…" hyperlink found on some of the importer wizard panels.

Topology Units: "Bodies" vs "Faces" Suggestions

· For the most memory efficient and fastest imports, always use "Bodies". Each CAD "part" will be imported as one body object, and possibly one additional "quilt" object. This mode will also allow for crack-free mesh creation, whereas the "Faces" mode will not.

· Sometimes materials will be assigned to the "face level" in the CAD model and not the "body" level. In such cases, enable the "Faces" radio button and always make sure the "Enable Hierarchy Optimization" option is enabled on the last importer panel. "Faces" import mode can be memory inefficient and slow because each CAD "part" will be imported as many individual objects, each object corresponding to one NURBS surface from the original CAD part. Also, crack-free mesh creation cannot be provided since each NURBS surface is imported independently of each other.

"Hierarchy Optimization" Suggestions

· This is absolutely the most important option to keep enabled in most cases. It can make all the difference between importing a CAD model quickly, with little memory usage and the fewest objects verse importing it slowly, with all memory being used up, and with an excessive number of objects. This is particularly true if the Topology radio buttons are set to "Faces". This command will collapse all children objects inside a grouping folder to a single object, and remove extraneous hierarchy folders. It can have profound results, in particular, for CAD models imported into 3ds Max, Maya and Lightwave. This option is not enabled during NURBS surface import since it would otherwise convert all the NURBS to polygons during the collapse process.

Scaling of the Model Suggestions

· Model scaling is an important, yet often overlooked aspect of the CAD import process by our users.

· In a nutshell, you should make sure your imported model generally ranges from 1x1x1 to 1000x1000x1000 units in size. Often we see customers importing a model which is only 0.001 units across - most downstream programs do not have the accuracy to display, render or manipulate such small models. Ditto on the model being too large (e.g. 1 million units wide).

· After your first file import use the destination program to determine the overall width, height and depth of the model, in general scaling terms. This can often be done by moving the cursor across the model and watching the current "XYZ Location" status bar message. If the model is too large, re-import it and change the "Additional Scaling To Apply" type-in box to a number such as 0.1, 0.01 or 0.001 (10x, 100x and 1000x times smaller). If the model is too small, re-import it and change the "Additional Scaling To Apply" type-in box to a number such as 10, 100 or 1000 (10x, 100x and 1000x times larger).

General Suggestions

· Always choose the "Expert Mode" so that you can control all the options discussed above.

See also:

Main Index Page of This Online Help System


Important Runtime Information, How-To’s, and Execution Notes

· Why do materials not get imported for some of my models?

Materials (colors, etc.) can either be applied on a "per-body" basis or on a "per-face" basis. Hence, you can control whether to import the Solid Edge model by-body or by-face through this panel (see the next paragraph about how to change this mode). Also, Solid Edge allows new materials to be applied on the assembly level, overriding materials at the part level. This importer will show the materials assigned at the part level since that is the lowest part of the inheritance tree for materials in non-CAD programs.

· Directory "write" privileges are required

You will need to have "write privileges" to the Okino "vcplugin64" directory in order to use the Solid Edge importer. The filename you choose to import is copied into the "imp_se.ini" file for use later on in the importer conversion process. If you do not have these privileges then you will wonder why you cannot select a new filename.

· Load in Solid Edge files from a local directory, not a remote networked directory

The Solid Edge "reader component" DLLs (used for "Display List" import mode), provided by Siemens Corp, have been known to not open assembly files from a remote, networked directory. If this occurs on your machine, copy the files to a local directory.

· How do I fix imported models with "Cracks" between adjacent polygon faces?

If you are finding that holes or cracks appear between adjacent faces of the imported Solid Edge data, then use "Expert Mode" during an import process and set the "Topology Units" option to "Bodies" on the Expert Precision Options # 2 wizard panel. By selecting "Bodies" Solid Edge is able to use equal surface subdivision on both sides of adjacent faces, thus eliminating the cracks.

· Objects which are nicely curved in Solid Edge are imported as "chunky" curves. Why?

If you are finding that objects which have nicely curved edges in Solid Edge are being imported with edges that look faceted or "chunky", there are two solutions to this problem which stem from the method in which Solid Edge converts the solid data to polygons. First, make sure you are running a recent Solid Edge service pack; if the problem still persists then proceed to the section above, "How do I fix imported models with "Cracks" between adjacent polygon faces?"; if the edge between two surfaces is faceted or chunky then you need to use the "Import by Body" method to ensure Solid Edge stitches these adjacent edges together prior to converting the data to polygons.

· My model appears very small when imported into the destination program. Why?

If you created your Solid Edge data in "millimeters" then the model will appear about 1000 times too small when imported into the destination program. The solution is to rescale the imported data to the size you desire using the drop-down scaling combo box shown on the Errors, Statistics & Scaling panel. You can also use this panel to match the source CAD units from Solid Edge to the destination units of your modeling program; for example, 3ds Max uses "inches" by default, Lightwave uses "centimeters" and Maya uses "meters".

· When using display list import I am getting a "ColeDispatchException [AssemblyReader::Open]" fatal error. Why?

This problem had been reported once. It is due to bugs in the Solid Edge assembly reader code and DLL provided to Okino from UGS (makers of Solid Edge). We have found that if you load the assembly into Solid Edge and re-save it then these sort of errors become minimized.

· Why do I get "COleException]: Call was rejected by callee"?

To date this has only been seen by the Okino developers while testing the first release of Solid Edge Synchronous v100. For some reason Solid Edge’s COM server no longer wanted to talk with anyone else. Rebooting our machines solved this unusual and rare occurrence.

· When using display list import I am getting a "ColeDispatchException [AssemblyReader::Open]" fatal error. Why?

This problem had been reported once. It is due to bugs in the Solid Edge assembly reader code and DLL provided to Okino from UGS (makers of Solid Edge). We have found that if you load the assembly into Solid Edge and re-save it then these sort of errors become minimized.

· Importing via "Automation" mode fails inside Autodesk 3ds Max. Why?

This happens infrequently and only for some random 3ds Max users. 3ds Max v6 and newer introduced an unknown bug whereby "COM" would become broken and thus not allow the "Automation" mode of the Solid Edge importer to function. The solution has been simple for all: perform a "File/New" operation inside of 3ds Max prior to the Solid Edge import process and that will reset this internal bug of 3ds Max.

· The import process will just not work. What do I do?

The Solid Edge importer is known to always work for everyone. If you are using the "Automation" import option then you must make sure that you have a recent service pack of Solid Edge installed on the same computer that this import converter is running on. If all else fails simply send email to "support@okino.com" and we will help you through the import problem.

See also:

Runtime Suggestions on How To Use the CD Importers Properly & Efficiently

Visual Snapshot Index of Each Import Converter Panel

The File Import Process Using Okino’s PolyTrans or NuGraf

Solid Edge "COM Automation Server" - An Overview


COM Automation Server - An Overview

Solid Edge "COM Automation Server", An Overview

When importing part or assembly data from a live running copy of Solid Edge, the data is transferred from Solid Edge to the Okino side of the pipeline using the Solid Edge "COM Automation Server Interface". This is an exposed set of functions which Solid Edge "publishes" to the outside world. Okino's Solid Edge importer queries all the part, assembly and material data from the running copy of Solid Edge using this COM interface.

Such a pipeline is exemplified in this diagram:

In this diagram, an Okino compliant software package (such as NuGraf, PolyTrans, 3ds Max or Maya), on the left side, has asked Microsoft Windows to open up the application which "understands" Solid Edge data files. Windows then executes Solid Edge, the application on the right side above, and loads in the specified Solid Edge data file. Using Microsoft "COM" technology, the Okino application on the left side (the "client") obtains direct access to the internal routines and data of Solid Edge on the right side (the data "server"), as if the two programs were running as one. Object mesh data, hierarchy and materials are then directly transferred to the Okino application for subsequent rendering or further data translation. Once the conversion has taken place the connection is closed and Solid Edge is allowed to exit.

See also:

Visual Snapshot Index of Each Import Converter Panel

The File Import Process Using Okino’s PolyTrans or NuGraf

Important Runtime Information, How-To’s, and Execution Notes


Alternative Methods to Importing Solid Edge Data

If you do not, or cannot (for whatever reason) import assemblies via this specialized Solid Edge import converter, then there are some alternatives by exporting explicit 3D files from Solid Edge directly and then importing them into Okino software.

The Solid Edge export file formats supported by Okino software are shown in the table below. However, not all of these file formats can output Solid Edge assemblies as well as the Okino Solid Edge import plug-in can import them directly. In particular, objects might be output as a single entity, hierarchy might be lost, materials might be dropped, or data integrity might be jeopardized (such as when exporting to IGES as NURBS). The following table itemizes our findings from tests we have performed when exporting Solid Edge data to Okino software:

File Format | Entity Type | Data Integrity? | Supports Hierarchy? | Supports Materials?
IGES | Solids |  | Part hierarchy | Yes
JT | Solids/Mesh |  | Part hierarchy | Yes
XGL/ZGL | Mesh | Basic geometry & color info. | No, and no part names | Yes, very nice
STEP | Solids |  | Part hierarchy | No
Parasolid | Solids |  | Part hierarchy | No
ACIS .sat | Solids |  | No | No
STL | Mesh | Output as single object | No | No

In general terms, we recommend using one of IGES, JT or XGL. XGL will create the nicest materials (colors) but part names and hierarchy are not available.

See also:

Visual Snapshot Index of Each Import Converter Panel

The File Import Process Using Okino’s PolyTrans or NuGraf

Solid Edge "COM Automation Server" - An Overview

Important Runtime Information, How-To’s, and Execution Notes


The File Import Process Using Okino's PolyTrans Or NuGraf

Once PolyTrans/NuGraf, the Solid Edge plug-in and Solid Edge have been installed on your machine, a typical import process proceeds as follows (the process is similar when importing directly into 3ds Max or Maya directly):

· From the NuGraf File/Import menu, or the PolyTrans Translate!/Import menu, select "Solid Edge File...".

· Solid Edge executes.

· The Solid Edge import wizard appears inside the NuGraf or PolyTrans software, showing the Intro Panel. The "Next" button is pressed.

· The Data Source Selection panel appears next. This allows you to choose between reading in the data from a Solid Edge file located on your hard disk (a .prt or .asm file), or importing data from the currently open Solid Edge document.

§ If you select the "Open document file" radio button and press "Browse" then the Microsoft Windows file selector dialog box will appear. One or more Solid Edge part (.par), assembly (.asm), sheet metal (.psm) or weldment (.pwd) files should be chosen. Solid Edge v20 or older weldment files need to be re-saved from Solid Edge v100 (synchronous versions) if you wish to import via the "Display List" import method. Assembly files are preferred since they contain more info. The files are loaded into the running copy of Solid Edge once you press the "Next" button.

· Once the source data file has been specified, you will be presented with options on how the data is to be opened. This can be done by "Display List" or "Automation". Display list will allow .prt, .asm, .psm and .pwd files to be opened without a local copy of Solid Edge on your machine; however, control over the number of polygons and querying of certain data items will not be possible. The automation method opens the file in a running copy of Solid Edge and transfers the data using a "COM Server" interface for greater data connectivity. The automation method also allows you to re-fresh an existing scene with updated or modified data from the live running copy of Solid Edge.

· The Beginner/Expert Mode panel appears next. This allows you to choose between further panels which are suitable for beginners, or for experts who want ultimate control over the import conversion process.

· If the beginner mode is selected, then the next panel will show the Beginner Precision options. This panel determines what type of geometry attributes are imported (vertices, normals, tangents or auto-computed normals) as well as how many polygons will be used to approximate the parametric solid surfaces of the objects inside Solid Edge (the surface tolerance deviation). Clicking the "Next" button will advance to the last panel of this introduction (the Errors & Stats panel).

· If the expert mode is selected, then the next panel will show the first of two Expert Precision options. This panel determines if polygons, polygons plus computed normals, or polygons + normals + uv texture coordinates + tangent vectors will be imported from Solid Edge. Each increasing level will take longer to import the data.

· The next expert level panel will show the second of two Expert Precision # 2 options. This panel will allow you to further refine which polygon attributes are imported, as well as determine which the objects should be "imported by body" (as one chunk) or "imported by face" (multiple chunks per object); each has its benefits and disadvantages.

· The second last expert level panel will show the Material Import options panel. In the fashion of many Okino import and export converters, this is a key options panel which allows you to modify the imported material properties from Solid Edge so that they will render properly in the destination rendering program. Solid Edge displays models in OpenGL and as such many models are overly saturated in ambient or diffuse color; this saturation of color does not look good in a photo-realistic rendering program. By pressing the "New" or "Details" button, the Material Tweaks sub-dialog box will appear; this dialog box provides a wealth of methods to have the imported material characteristics automatically modified to your liking. Multiple "tweak methods" can be user defined and saved between invocations of this import converter.

· The last panel is the Errors, Statistics & Scaling. This presents some options to control how import converter errors are handled, and whether statistics should be displayed after the import process is completed. It also provides two drop-down combo boxes which allow the imported data to be scaled up in size or scaled down in size, as well as automatically scaled to match the source and destination scaling units.

Once the import wizard goes away, the solid model data in Solid Edge is tessellated into triangular polygons and transferred into Okino's software. The process completes once the entire model has been imported.

See also:

Visual Snapshot Index of Each Import Converter Panel

Solid Edge "COM Automation Server" - An Overview

Important Runtime Information, How-To’s, and Execution Notes


Intro Panel Options

This is the first panel which appears once the Solid Edge import converter has been loaded.

See also:

Visual Snapshot Index of Each Import Converter Panel

Solid Edge "COM Automation Server" - An Overview

Important Runtime Information, How-To’s, and Execution Notes


Data Source Selection Options

This second panel determines whether the import converter will obtain the data from the currently open Solid Edge document, or if a Solid Edge assembly/part file should be opened first in Solid Edge. If you wish to select a Solid Edge part (.prt) or assembly file (.asm) on disk, then press the "Browse" button and select one or more part or assembly files; the files will be loaded into Solid Edge once you press the "Next" button.

If the "Currently being edited in Solid Edge" option is grayed out, yet Solid Edge is presently open with a valid model document, exit the Solid Edge import converter and start it again. The import converter only checks whether an open document exists when it first begins execution of the import wizard.

See also:

Visual Snapshot Index of Each Import Converter Panel

Solid Edge "COM Automation Server" - An Overview

Important Runtime Information, How-To’s, and Execution Notes


Beginner/Expert Mode Options

This simple panel determines whether subsequent panels will show simpler beginner options, or a variety of more complex options for expert users. Click on the telephone image for beginner mode, or the video camera for expert mode. We recommend the expert mode.

If you want to reset all of the import converter options to the default start-up values, then check-mark the "Reset import parameters before continuing" check box before pressing the "Next" button.

See also:

Visual Snapshot Index of Each Import Converter Panel

Solid Edge "COM Automation Server" - An Overview

Important Runtime Information, How-To’s, and Execution Notes


Display List vs. Automation Import Options

The Solid Edge importer can import data using two different mechanisms:

"Display List Mode"

When the radio button is set to "Open Display List Data" the importer will read in the raw polygon data and assembly hierarchy info contained in each .asm assembly file or .prt part file located on disk. There is no need to have a copy of Solid Edge on your machine if you use this mode. This is the simplest and most direct route to opening and importing Solid Edge files. However, the main drawback is that the quality of the model (the number of polygons used to represent the solid data) cannot be modified, as the mesh model is predefined inside the .prt files.

"Automation Mode"

When the radio button is set to "Connect Directly to Solid Edge via Automation" the importer will start up a hidden copy of Solid Edge in the background and have the selected files(s) loaded into it. Then the Solid Edge importer will use the COM interface to query and import the assembly and part information from the running copy of Solid Edge into the local PolyTrans software. While a bit slower than the "Display List Mode" (when starting up Solid Edge), this mode has the benefit of allowing you to control the quality of the imported model (the number of polygons used to represent the solid data), as well as querying additional data such as uv coordinates & UV tangent vectors, etc.

See also:

Visual Snapshot Index of Each Import Converter Panel

The File Import Process Using Okino’s PolyTrans or NuGraf

Solid Edge "COM Automation Server" - An Overview

Important Runtime Information, How-To’s, and Execution Notes


Beginner Precision Options

For beginners, this is one of the most important import converter panels. It determines "how much" data, how accurately the solid object data from Solid Edge is converted to polygons, and how quickly the import process proceeds.

"Data Completeness" Slider

This slider determines which type of data is actually imported from Solid Edge. Setting the slider all the way to the left will import the least attributes associated with the model, while setting the slider all the way to the right will import the most attributes possible. The increments on this slider are related to the options on the Expert Precision panel as follows:

Minimum - Import polygon data only. The imported data will appear faceted due to the lack of vertex normals. The data will also be "imported by body" which means that each solid entity in Solid Edge (a body) will be imported as its own single object (rather than various sub-objects).

Some - Import polygons and vertex normals (smoothing info). This is useful is you want the imported objects to appear smooth, but you do not want to import uv texture coordinates for texture mapping or UV tangent vectors for bump mapping. Data is "imported by body" (see above).

Most - Import polygons, vertex normals and uv coordinates. This is useful is you want the imported objects to appear smooth, and to have default texture coordinates. The data will be "imported by face" which means that each solid will be imported as multiple sub-pieces, arranged in a hierarchical manner.

All - Import polygons, vertex normals, uv coordinates and tangent vectors. Same as above except that tangent vectors will be useful for adding bump mapping to objects via texture maps. Data is "imported by face" (see above).

"Surface Precision" Slider

Data inside Solid Edge is represented as "solids". When importing these solids into Okino software they must be approximated by a mesh of connected polygons (triangles). This slider determines how accurately the original solid surfaces are approximated by polygons. If the slider is set all the way to the left, then few polygons will be used and the approximation will be poor; however, the import process will proceed rather quickly. If the slider is set all the way to the right then many polygons will be used and the approximation should be quite accurate; however, the import process speed may be slow due to the larger number of polygons that must be imported.

See also:

Visual Snapshot Index of Each Import Converter Panel

Solid Edge "COM Automation Server" - An Overview

Important Runtime Information, How-To’s, and Execution Notes


Expert Precision Options

This is the first expert mode options panel which controls "how much" data, how accurately the solid object data from Solid Edge is converted to polygons, and how quickly the import process proceeds.

"Data Imported" Radio Buttons

These radio buttons determine which type of data is actually imported from Solid Edge:

Polygons Only - Only polygon data is imported. The imported data will appear faceted due to the lack of vertex normals.

Normals and Polygons - Polygon data will be imported as well as vertex normal (smoothing) information. This is useful if you wish the imported data to appear smooth. The determination if the vertex normals will be automatically computed (using a smoothing algorithm in the OLE D&M import converter), or queried from Solid Edge, is selected on the next Expert Precision Panel # 2.

Query Normals, uv & Tangent - Polygon data will be imported as well as vertex normals, vertex uv texture coordinates and vertex UV tangent vectors. This is useful if you wish the imported data to appear smooth, to be able to easily assign 2D bitmap texture maps to the imported objects and to be able to easily assign 2D bump map textures to the imported objects.

"Surface Deviation" Slider

This option is only available for the "Automation" import method and not the "Display List" import method.

Data inside Solid Edge is represented as "solids". When importing these solids into Okino software they must be approximated by a mesh of connected polygons (triangles). This slider determines how accurately the original solid surfaces are approximated by polygons. If the slider is set all the way to the right, then few polygons will be used and the approximation will be poor; however, the import process will proceed rather quickly. If the slider is set all the way to the left then many polygons will be used and the approximation should be quite accurate; however, the import process speed may be slow due to the larger number of polygons that must be imported. The numeric value shown to the right of the slider is the maximum allowable deviation between the ideal solids surface and that of the approximated polygon surface; as this number gets smaller a larger number of polygons must be created in order to better approximate the ideal solids surface.

I Would Also Like to Fine Tune the Advanced Options

If this check box is enabled then the Expert Precision Panel # 2 will be shown when the "Next" button is pressed. This subsequent panel will allow further refinement of the import options.

See also:

Visual Snapshot Index of Each Import Converter Panel

Solid Edge "COM Automation Server" - An Overview

Important Runtime Information, How-To’s, and Execution Notes


Expert Precision Options # 2

Expert Precision # 2 Options

This expert mode options panel provides control over specialized aspects of the import process. It is only displayed if the "I Would Also Like to Fine Tune the Advanced Options" checkbox is enabled on the previous Expert Precision Panel # 2 dialog box.

The one option that might be most interesting to users is the "Topology Units" (see below).

Optimize vertices to speed up import processing"

If this check box is enabled then all duplicated (redundant) vertices of the imported data will be deleted before any normals, uv coordinates or UV tangent vectors are queried from Solid Edge. This will greatly speed up the import process because redundant data queries will not have to be made.

Normal Attribute Processing (Pop-Down List Box)

This pop-down list box determines, absolutely, how vertex normals are to be created for the imported polygon data. These options override the vertex normal import methods selected on the previous Expert Precision Panel # 1:

-Skip- No vertex normals will be imported. The imported polygon data will not appear smooth when rendered.

Generate - A smoothing algorithm in the OLE D&M import converter will be enabled to automatically create vertex normals based on smoothing angle. This will create only an approximation of the real vertex normals from Solid Edge. Since the real vertex normals are not imported from Solid Edge, this option is faster than asking Solid Edge for the accurate vertex normals. If this option is chosen then the "Smoothing Angle" text type-in box becomes enabled; higher values (near 90 degrees) will make your objects appear highly smoothed (no sharp corners) whereas lower values (around 15 to 20 degrees) will make your import objects appear more faceted, although smooth where they should be.

Import Only - The true vertex normals will be queried from Solid Edge one by one. This is much slower but produces more accurate results.

Import & Optimize - The same as "Import Only", but the vertex normals will also be optimized so that any redundant coordinates are deleted.

uv Texture Coordinates (Pop-Down List Box)

This option is only available for the "Automation" import method and not the "Display List" import method.

This pop-down list box determines, absolutely, how vertex uv texture coordinates are to be imported from Solid Edge. These options override the vertex uv texture coordinate import methods selected on the previous Expert Precision Panel # 1:

-Skip- No vertex uv texture coordinates will be imported. You will not be able to apply 2D bitmap textures to the imported objects without these uv texture coordinates.

Import Only - The true vertex uv texture coordinates will be queried from Solid Edge one by one.

Import & Optimize - The same as "Import Only", but the vertex uv texture coordinates will also be optimized so that any redundant coordinates are deleted.

UV Tangent Vectors (Pop-Down List Box)

This option is only available for the "Automation" import method and not the "Display List" import method.

This pop-down list box determines, absolutely, how vertex UV tangent vectors are to be imported from Solid Edge. These options override the vertex UV tangent vector import methods selected on the previous Expert Precision Panel # 1:

-Skip- No vertex UV tangent vectors will be imported. You will not be able to apply 2D bitmap bump mapping textures to the imported objects without these tangent vectors.

Import Only - The true vertex UV tangent vectors will be queried from Solid Edge one by one.

Import & Optimize - The same as "Import Only", but the vertex UV tangent vectors will also be optimized so that any redundant coordinates are deleted.

Topology Units: Bodies or Faces

This option is only available for the "Automation" import method and not the "Display List" import method.

Because Solid Edge is a solid modeling package, internally it represents solids in "Brep" form (boundary representation). An object consists of a "body", which is made up of "shells" and each shell is made up of "faces". These faces are not to be confused with polygon faces of other programs.

If the "Bodies" option is chosen on this panel then each major object will be imported as one mesh object and you will not be able to easily assign materials to sub-components of the imported object.

If the "Faces" option is chosen on this panel then each major object will be imported as several sub-mesh objects, stored under one hierarchical parent folder (or "null object" as alternative lingo). Since the object is imported as several sub-objects, you may find it easier to assign materials.

If the "Query normals" radio button is selected on the previous Expert Precision Panel # 1 then the "Topology Units" radio buttons will always be forced to the "By Face" import option. This is because the import converter can only query accurate normals from Solid Edge when importing by individual faces. If the "Polygons Only" or "Normals and Polygons" radio buttons are selected on the Expert Precision Panel # 1 instead, then you have a selection of importing by body or importing by face.

** NOTE **

You may find that importing "By Body" to produce better tesselation results and less "cracks" or holes between adjacent edges. This is because each adjacent "face" of the body is taken into account when the two faces are tesselated (so that no holes appear between faces). If you import "By Face" then holes or "cracks" may appear between adjacent faces.

Flip Model so that 'Y' Axis is 'Up'

By default the data is imported so that the 'Y' up axis in Solid Edge becomes the 'Y' up axis in Okino software. If this checkbox is enabled, then the imported data will be reoriented so that the 'Z' axis in Solid Edge becomes the 'Y' Up axis in Okino software.

See also:

Visual Snapshot Index of Each Import Converter Panel

Solid Edge "COM Automation Server" - An Overview

Important Runtime Information, How-To’s, and Execution Notes


Material Import Options

In the fashion of many Okino import and export converters, this is a key options panel which allows you to modify the imported material properties from Solid Edge so that they will render properly in the destination rendering program. Solid Edge displays models using OpenGL and as such many models are overly saturated in ambient or diffuse color; this saturation of color does not look good in a photo-realistic rendering program. By pressing the "New" or "Details" button, the Material Tweaks sub-dialog box will appear; this dialog box provides a wealth of methods to have the imported material characteristics automatically modified to your liking. Multiple "tweak methods" can be user defined and saved between invocations of this import converter. The default action is to not modify any imported material characteristics; however, you will often find that imported Solid Edge models appear "too ambient" or "too diffuse".

Import Method (Pop-Down List Box)

By default, three "material import processing" methods have been provided for you by clicking on the pop-down list box. You are also free to define your own methods by pressing the "New" button on the panel which will call up the Material Tweaks sub-dialog box:

Do Not Import Material Properties - No material properties will be imported at all.

Preserve Numerical Values - All materials will be imported from Solid Edge without any change or tweaking.

Preserve Appearance (Recommended) - The material shading coefficients will be set to the following values, ensuring that the model should look ok when rendered:

· Diffuse shading coefficient = 0.4

· Ambient shading coefficient = 0.3

· Specular shading coefficient = 0.7

· Highlight value = 0.12 (0 = wide highlight, 1.0 = narrow highlight)

· Emission (luminous) shading coefficient = 0

· Opacity (inverse of transparency) = 1.0 (fully opaque)

See also:

Visual Snapshot Index of Each Import Converter Panel

Solid Edge "COM Automation Server" - An Overview

Important Runtime Information, How-To’s, and Execution Notes


Material Tweak Options

This sub-dialog box provides ultimate control over how imported material properties should be modified so that the imported model can be rendered nicely in a photo-realistic rendering program. All too often the imported model appears "too ambient" or "too diffuse", resulting in rendered images that are washed out or with no gradual shading effects visible. By default you should use the "Preserve Appearance" pre-defined import method.

First, to add a new material processing method, press the "New" button on the Material Import panel. This will cause the sub-dialog box to appear in which you can set your custom material import processing options.

As an explanation of the various shading parameters listed on the sub-dialog box:

Diffuse: This controls the amount of color reflected from an object based on the direct light shining on it. A good default value is 0.4.

Ambient: This controls the amount of color reflected from an object based on the ambient light in a scene. A good default value is 0.1 through to 0.3.

Specular: This controls the intensity of the highlight on an object. A good default value is 0.7.

Highlight: This controls the width of the specular highlight on an object (0 = wide, 1.0 = very narrow). A good default value is 0.12.

Emission (luminous): This controls how much color is added to an object, irrespective of any light which shines on it (the higher the value, the more the object will appear to glow). In general you should keep this value at 0.

Opacity: This is the inverse of transparency. 0.0 will make the object fully transparent, while at 1.0 the object will be fully opaque.

For each material property, several actions can be performed on it during the import from Solid Edge. Two sets of actions are provided, those which are performed when color values are being imported (diffuse, ambient, specular, emission) and those which are performed when single-valued shading parameters are being imported (highlight value and opacity).

The actions taken when importing color values are described as follows:

- Skip - : The color value is not imported (no color change is made).

Use Default Coefficient: This action imports the corresponding color with no change made at all, but the shading coefficient for the color will be set to a "pleasant" value resulting in 3D scenes which render "photorealistically" (in other words, without harsh or overly bright colors). These coefficients typically range from 0.3 through to 0.7. The "coefficient" mentioned here is the same as the "Shading Coefficients" on the "Color" surface attribute editor in Okino’s NuGraf Rendering System software.

Set Coefficient To: This behaves the same as "Use Default Coefficient" except that the shading coefficient for the color is set to a user specified value. Let’s assume you set all these shading coefficients to 1.0 (the worse case); this would result in a rendered scene which was oversaturated in color because of the total addition of ambient, diffuse and specular color components. To circumvent this problem (as is done in all 3D rendering packages), we "attenuate" each of these colors by a specific percentage so that they don’t saturate the final rendered image when the shading is done. Typically, the ambient coefficient is 0.1 to 0.3, diffuse is in the 0.3 to 0.5 range and specular coefficient should be about 0.7.

Normalize Color and Coefficient: This is a hybrid approach which tries to automatically "guess" at proper shading coefficient values using the raw colors imported from Solid Edge. As mentioned, these shading coefficients are needed to create nice looking (nicely shaded) images in a photo-realistic rendering program. Solid Edge, however, only allows you to specify the raw colors of an object and not how the ambient, diffuse and specular colors are to be mixed together during a shading operation. If this drop-down box option is chosen, then the shading coefficient will be derived directly from the relative intensity of the imported color. For example, if the imported diffuse color is (0.4, 0, 0), which is 40% of full-bright red, then the diffuse shading coefficient will be set to 0.4 and the diffuse color will be modified to be (1, 0, 0). When the new color (1,0,0) and the new shading coefficient (0.4) are multiplied together, it results in the original color imported from Solid Edge (0.4, 0, 0). In general you may wish to use the "Use Default Coefficient" option to get good rendered results.

The actions taken when importing shading parameter values are described as follows (highlight value and opacity):

- Skip - : The material parameter is ignored during import.

Import Unchanged: The material parameter is imported as is, with no change.

Unconditionally Set To: The material parameter is not imported but rather it is set to the numeric value on the dialog box.

Import and Crop by: The material parameter is imported and remains unchanged if it is less than the numeric value on the dialog box. If it is greater, then the imported value will be clamped to be no greater than the numeric value on the dialog box.

Import and Scale by: The material parameter is imported and scaled by the numeric value on the dialog box.

See also:

Visual Snapshot Index of Each Import Converter Panel

Solid Edge "COM Automation Server" - An Overview

Important Runtime Information, How-To’s, and Execution Notes


Errors, Statistics & Scaling

Errors, Statistics, Scaling & Automatic Units Matching

One of the primary uses of this panel is to set up the "units matching". Data from Solid Edge comes across the conversion pipeline in terms of "meters". However, the destination 3D program may not be using meters as its default measurement units. For example, 3ds Max uses "inches" by default, Lightwave uses "cm" and Maya uses "meters". The combo boxes on this panel allows the measurement units to be matched, as well as additional scaling to be applied to the imported geometry data.

This options panel also determines whether the import converter will "try its best" to overcome COM errors reported by Solid Edge, and whether statistics will be printed after all the data has been imported.

Data Scale

"Units conversion" is often an important aspect of importing CAD files. People who create 3D models in a modeling package will do so using a specific units system, such as meters or feet. However, when these models are imported into another 3D package that uses a different default units system (such as Lightwave which uses centimeters), a "units conversion" operation needs to occur (the imported model geometry needs to be rescaled).

This import panel determines what will be done when the units defined in the Solid Edge file do not match current internal system units. If the units do not match, the Solid Edge importer will rescale the imported geometry based on the ratio between the Solid Edge units and the internal system units.

Unit of Measurement

You need to set this combo box to the measurement units system in effect for your destination 3D program. For example, set it to centimeters for Lightwave, inches for 3ds Max, centimeters for Maya, etc.

If you are importing into the Okino PolyTrans or NuGraf programs then you can either set the destination units measurement system via this combo box or set the combo box to "Current System" and then set the measurement system inside the main PolyTrans/NuGraf program (Edit/Preferences/Startup Preferences/Other/System Units).

Ignored | No units; never do any geometry scaling
Current System | Scale data to match current internal Okino units
Use Document | Set Okino units to the file’s units. No scaling done
Microinches | 1e-6 inches
Mils | 1e-3 inches
Inches | 2.54 centimeters
Feet | 12 inches
Yards | 36 inches
Miles | 1.6 kilometers
Microns | 1e-6 meters
Millimeters | 1e-3 meters
Centimeters | 1e-2 meters
Decimeters | 1e-1 meters
Meters | 3.28 feet
Kilometers | 0.62 mile
Custom | Custom units are in effect

If the "Custom" option is chosen then the numeric value contained in the "Additional scaling to apply" edit control defines the "units per meter" scale factor for a custom unit system. For example, if you were to enter "0.62" into the type-in box then this would be equivalent to the "Kilometers" units measurement system.

Additional Scaling to Apply (Combo Box)

This drop-down combo box allows imported geometry to be scaled up or down in size by units of 10, 100 or 1000 times. You are free to enter your own scaling factor into the type-in portion of the combo box if you wish (such as "5000"). If you created your model within Solid Edge using "millimeters", for example, then the model will appear about 1000 times too small when imported into the destination program. The solution is to select a scaling option on this wizard panel appropriate for the size of the data as it appears in Solid Edge. For example, if you model in millimeters within Solid Edge then you will want to scale up by 1000 units so that the imported model will not look tiny.

NOTE: If the "Unit of Measurement" combo box is set to "Custom" then the "Additional scaling to apply" edit control defines the "units per meter" scale factor and not an absolute scaling factor.

Runtime Import Options

Tolerate File Integrity Errors

If this option is enabled then the converter will not stop if it receives unexpected data as a result of a data query to Solid Edge; in this case the import converter will just skip over that element and continue importing.

Report Statistics About the Imported File

If this check box is enabled then statistics will be reported after the data has been imported.

Merge Triangles To Quads, Max Angle = #

Solid Edge, and all top-6 MCAD programs since the invention of NURBS in the 1980’s, always output triangular meshes and not quad meshes. This is because quads cannot accurately represent the curvature of NURBS surfaces.

This option is a post-processing step that merges triangles back to quadrilateral polygons (4 sided polygons). The number of vertices remain the same but the overall number of polygons are reduced.

If this option is enabled (check marked) then an algorithm will be invoked which merges multiple polygons into quads. If two adjacent triangles are nearly co-planar then they will be turned into a quadrilateral. The vertices of the adjacent edges must be welded together (shared) for this operation to proceed properly.

The test for co-planar polygons (polygons which are almost on the same plane as each other) is determined by the "Max angle" type-in box. This value is measured in degrees. Values near 0 will require that adjacent polygons be very much co-planar with each other, while higher values will allow polygons that meet at an angle to be considered. For example, if you have a curved object made of triangles then try setting the angle to 4 to 7 degrees. Higher values will allow more polygons to be merged.

NOTE: you can also apply this merging algorithm via the "Polygon Processing" functionality found in the stand-alone Okino software. On that dialog box you would invoke the "Merge Co-Planar Polygons into larger polygons" function. That alternative version also provides some more controls over whether vertex normals, vertex colors and vertex uv’s are to be taken into account (they are all taken into account when invoked via the polygon reduction system).

See also:

Visual Snapshot Index of Each Import Converter Panel

Solid Edge "COM Automation Server" - An Overview

Important Runtime Information, How-To’s, and Execution Notes


AFX_HIDP_default

No Help Available

No help is available for this message box.

<< If you wish to author help specific to each message box prompt, then remove the AFX_HIDP_xxx values from the [ALIAS] section of your .HPJ file, and author a topic for each AFX_HIDP_xxx value. For example, AFX_HIDP_INVALID_FILENAME is the help topic for the Invalid Filename message box. >>


HID_HELP


HID_HT_NOWHERE

No Help Available

No help is available for this area of the window.


HID_WIZBACK


HID_WIZFINISH


HID_WIZNEXT


HIDC_ANGLE

This value controls the smoothing criterion used when normals are being generated (as opposed to being queried from the server). It is based on the angle between abutting polygons; common smoothed vertex normals will be computed if the angle between their geometric surface normals is less than the angle specified.

Defaults to 45 degrees. Increase this value if the imported object appear to have overly rough surface. Decrease this value if the surface appears to be overly smoothed.


HIDC_BANNER


HIDC_BEGINNER


HIDC_BODIES


HIDC_ERROR_TORERANT


HIDC_EXPERT


HIDC_FACES


HIDC_FLIP_Y_UP

If this option is enabled then the model will be rotated so that its Up axis is aligned with the positive Y-axis instead of the positive Z-axis.


HIDC_NORMALS


HIDC_OPEN_CURRENT


HIDC_OPEN_FILE


HIDC_OPTIMIZE_VERTICES


HIDC_REPORT_STATS

If this checkbox is enabled then the import converter will print out the number of objects, polygons, normals, texture coordinates, tangent vectors and surfaces that were parsed from the SAT file.


HIDC_RESET_DEFAULT


HIDC_TANGENTS

If this checkbox is enabled then the import converter will import proper tangent vectors for each triangle vertex. Tangent vectors are necessary if bump map texture image is to be applied to the object at some time in the future.


HIDC_UV

If this checkbox is enabled then the import converter will import proper texture (u,v) coordinates for each triangle vertex. Texture coordinates are necessary if a bitmap texture image is to be applied to the object at some time in the future


HIDP_INVALID_PATH

Invalid Path

HIDP_INVALID_PATH